/**
 @file
 @author darkside86-w00t
 
 Allows Lua bindings to happen at any scope in any source file, similar to the 
 COMMAND macro system.
*/

// this "abuse of globals" should cut down writing so many luaopen_'s for
// every single file in the whole project
//
#define ADDLUAUSERAPI(name) int __luauserapifuncindex_##name##__ = addluauserapi(#name, lua_##name)
#define ADDLUAPROTECTEDAPI(name) int __luaprotectedapifuncindex_##name##__ = addluaprotectedapi(#name, lua_##name)
#define ADDLUAUSERAPI_N(name, func) int __luauserapifuncindex_##name##__ = addluauserapi(#name,func)
#define ADDLUAPROTECTEDAPI_N(name, func) int __luaprotectedapifuncindex_##name##__ = addluaprotectedapi(#name,func)

#define ADDLUAUSERCLASS(name) int __luauserapiclass_##name##__ = \
	addluaclass(false, #name, luaopen_class_##name, NULL)
#define ADDLUAPROTECTEDCLASS(name) int __luaprotectedapiclass_##name##__ = \
	addluaclass(true, #name, luaopen_class_##name, NULL)

