--[[ delegate(object, object.method)
   |---------------------------------------------------------------------------
   | Creates a callable object out of a table and a method and returns it.
--]]---------------------------------------------------------------------------
function delegate(object, func)
    local dele = {
        obj=object,
        fn = func
    }
    setmetatable(dele, {
        __call = function(df, ...)
            df.fn(df.obj, unpack(arg))
        end
    })
    return dele
end



